#include <errno.h>
#include <error.h>
#include <stdlib.h>
#include <paths.h>

static inline void *xmalloc( size_t size )
{
	void *p = malloc( size );
	if ( !p )
		error( EXIT_FAILURE, errno, "malloc" );
	return p;
}
 
static inline void *xcalloc( size_t nmemb, size_t size )
{
	void *p = calloc( nmemb, size );
	if ( !p )
		error( EXIT_FAILURE, errno, "calloc" );
	return p;
}
 
static inline void *xrealloc( void *ptr, size_t size )
{
	void *p = realloc( ptr, size );
	if ( !p )
		error( EXIT_FAILURE, errno, "realloc" );
	return p;
}

static inline char *xstrdup( const char *s )
{
	char *r = strdup( s );
	if ( !r )
		error( EXIT_FAILURE, errno, "strdup" );
	return r;
}
